// Fenetre Richtext pour affichage de l'aide

#include "help.h"
#include "maindialogimpl.h"	// pour images

#include <qapplication.h>
#include <qhbox.h>
#include <qpushbutton.h>
#include <qtextview.h>
#include <qbrush.h>


static const char* sayings[] = {
    "<h1><b>Aide de LCDbin (version du 27/12/03) :</b></h1><br>"
    "<hr>"

    "<h2>Cette aide n'est pas encore complte car je n'ai pas eu "
	 "le temps de la finir !<br>"
	 "Pour l'instant cette version ne gre que les afficheurs 128x64, "
	 "ensuite elle devrait grer les afficheur 122x32 et les tailles perso.<br>"
	 "Pour toute information :</h2>"
	 "<hr>"
	 "Les afficheurs 128x64 sont disponibles sous la rfrence OGM128GN15D "
	 "(Orion Display Technologie) chez Lextronic France (www.lextronic.fr) au prix de 27euros "
	 "(prix indicatif)."
	 "<hr>"
	 "<h2><b>site : <u>http://sjeffroy.free.fr</u></b><br>"
	 "<b>email : <u>sj29fr@yahoo.fr</u></b><br>"
    "<hr>"
	 "<u>CLIQUEZ SUR SUIVANT et PRECEDANT pour LIRE l'AIDE !!! </u>"
	 "<hr>"
	 "<br><center><i>-- Sbastien JEFFROY --</i></center></h2>"
	 ,
	 
	 "<h2>Barre d'outils</h2>"
	 "<h3><u>Charger Bmp</u></h3>"
	 "Charge une image au format bitmap, png, xpm."
	 "<h3><u>Charger Bin</u></h3>"
	 "Charge une image ou une suite d'images (cf concatenation) au format binaire.<br>"
	 "<h3><u>CONCATENATION BINAIRES</u></h3>"
	 "Il faut taper une ligne de commande ou crire cette ligne dans un fichier .bat (batch)<br>"
	 "<b><i>copy /b image1.bin + image2.bin + image3.bin cible.bin</i></b><br>"
	 "ou <b><i>copy /b</i></b> excute une copie au format binaire, <b><i>imageX</i></b> sont des fichiers binaires "
	 "obtenus avec LCDbin, et <b><i>cible.bin</i></b> le fichier de destination.<br>"
	 "Vous pouvez ensuite ouvrir ce fichier .bin avec LCDbin ou IC-Prog pour la "
	 "programmation de votre EEPROM i2c."
	 "<h3><u>Sauvegarder Bmp</u></h3>"
	 "Sauvegarde l'image bitmap pralablement charge en mmoire "
	 "en image binaire suivant les options (voir aide options)."
	 "<h3><u>Sauvegarder Bin</u></h3>"
	 "Sauvegarde l'image Binaire affiche en image Bitmap. "
	 "Il faut utiliser les boutons prcdant et suivant pour voir "
	 "les diffrentes images d'un fichier binaire concatn (exemple 24C256.bin)"
	 "<h3><u>Imprimer</u></h3>"
	 "Pour l'instant cette option permet d'imprimer une image binaire."
	 "<hr>"
	 ,

	 "<h2>Options</h2>"
	 "<h3><u>Taille LCD</u></h3>"
	 "<u>Les options de Taille du LCD sont donc la uniquement pour dcorer !</u><br><br>"
	 "<h3><u>Organisation des ranges</u></h3>"
	 "Vous pouvez maintenant modifier l'ordre de stockage des fichiers binaires "
	 " l'ouverture comme  la fermeture. Personnellement j'utilise le mode "
	 "ranges 0-63 pages de gauche puis ranges 64-127 pages de droite. Mais si "
	 "vous prfrez crire sur l'afficheur la premire page de gauche  droite "
	 "(ranges 0  127) vous pouvez le faire en cochant (----->) au lieu de (--> -->).<br>"
	 "<u><i>Si l'image binaire apparat dans le dsordre c'est surement parce que vous "
	 "avez choisi le mauvais mode d'affichage des ranges (-->--> au lieu de -----> ou "
	 "vice versa)</u></i>"
	 "<hr>"
	 ,

	 "<h2>Onglet Bitmap</h2>"
	 "Affiche l'image bitmap et son chemin"
	 "<hr>"
	 
	 "<h2>Onglet Binaire</h2>"
	 "Affiche l'image binaire ou les images binaires d'un fichier concatn et son chemin"
	 "<h3><u>Nombre d'images</u></h3>"
	 "1 si fichier binaire contenant 1 image ; n si fichier concatn"
	 "<h3><u>Suivant / Prcdant</u></h3>"
	 "permet de visualiser les images d'un fichier concatn (si != 1)"
	 "<h3><u>Couleur</u></h3>"
	 "couleur de fond de l'image binaire (ouvre une palette)"
	 "<hr>"
	 
	 "<h2>Onglet Contenu Binaire</h2>"
	 "Affiche le contenu binaire du fichier au format hexadcimal.<br>"
	 "Il faut cliquer sur les items de la liste <b><i>\"image x\"</i></b> pour pouvoir changer d'image "
	 "et afficher son contenu binaire ainsi que l'aperu."
	 "<hr>"
	 ,

	 "<h2>Onglet Export ASCII</h2>"
	 "Permet d'exporter une image binaire en fichier texte sous 3 formes :<br>"
	 "<h3><u>Assembleur pour PIC :</u></h3> Tableau constant sous forme de dt<br>"
	 "<h3><u>'C' pour PIC :</u></h3>"
	 "Tableau  inclure dans vos programmes<br>"
	 "<h3><u>Personnalis :</u></h3>"
	 "A vous de voir...<br>"
	 "<h3><u>Tabulations (exemple) :</u></h3>"
	 "<i>\"$tab$tab\"</i> sera remplac par 2 tabulations dans le texte export.<br>"
 	 "<b>Regardez l'onglet Clipboard text pour voir le rsultat si vous n'tes pas sr.</b>"
	 "<hr>"
	 "<h2>Onglets Clipboard qpixmap et text</h2>"
	 "<h3><u>qpixmap</u></h3>"
	 "Affiche le contenu du presse papier s'il contient une image."
	 "<h3><u>text</u></h3>"
	 "Affiche le contenu du presse papier s'il contient du texte."
	 "<hr>"
	 ,

	 "<h1><b>A FAIRE :</b></h1><br>"
    "<hr><br><br>"
	 "30/12/03 impression Binaire sous forme d'index photo<br>"
	 "27/12/03 impression Binaire (images)<br>"
	 "24/12/03 option (Row 0-127 ou 0-63 puis 64-127)<br>"
	 "24/12/03 Menu d'aide avec <balises> (en cours)<br>"
	 "Aide html pour liens (QTextBrowser cf helpviewer) ??<br>"
	 "fichier .ini (cf XML xmlquotes)<br>"
	 "gestion multiple .bin (add Item + move up/down item)<br>"
	 "fusion 128*64 + 122*32 + gestion icones<br>"
	 "Voir version 122x32 pour size image + %1024 ...<br>"
	 ,

    0
};


HelpLCD::HelpLCD(QWidget *parent, const char *name )
    : QVBox( parent, name )
{
    setMargin( 5 );

    view = new QTextView( this );
    //view->setText( "This is a <b>Test</b> with <i>italic</i> <u>stuff</u>" );
    QBrush paper;
    paper.setPixmap( QPixmap( "marble.png" ) );
    view->setPaper( paper );

    view->setText( sayings[0] );
    view->setMinimumSize( 450, 250 );
	
	//// view->setMimeSourceFactory(??);//#####TEST pour PNG...
/*	QImageIO imageio;
	imageio.setFileName("XPM/home.xpm");
	imageio.read();

	 QMimeSourceFactory::defaultFactory()->setImage( "myimage", imageio.image()  );
*/
	//Now you can create a rich text QLabel with 
	/*QLabel* label = new QLabel(
      "Rich text with embedded image:<img source=\"myimage\">"
      "Isn't that <em>cute</em>?" );
		*/


    QHBox *buttons = new QHBox( this );
    buttons->setMargin( 5 );

    //bClose = new QPushButton( "&Close", buttons );
	 bPrev = new QPushButton( "<< &Precedant", buttons );
    bNext = new QPushButton( "&Suivant >>", buttons );

    bPrev->setEnabled( FALSE );

    //connect( bClose, SIGNAL( clicked() ), qApp, SLOT( quit() ) );
	 connect( bPrev, SIGNAL( clicked() ), this, SLOT( prev() ) );
    connect( bNext, SIGNAL( clicked() ), this, SLOT( next() ) );

    num = 0;
}


HelpLCD::~HelpLCD(void)
{

}

void HelpLCD::prev()
{
    if ( num <= 0 )
        return;

    num--;

    view->setText( sayings[num] );

    if ( num == 0 )
        bPrev->setEnabled( FALSE );

    bNext->setEnabled( TRUE );
 	

}

void HelpLCD::next()
{
    if ( !sayings[++num] )
        return;

    view->setText( sayings[num] );

    if ( !sayings[num + 1] )
        bNext->setEnabled( FALSE );

    bPrev->setEnabled( TRUE );
}





